/*-------------------------------------------------------------------
  1-Wire DS1820_02.c

  11-06-2011

  Basetta_PIC18F_28_03.c

  Processore:       PIC18
*/
//---I N C L U D E S-------------------------------------------------
#include <p18f2525.h>
#include "I:\__Lib\Lib1Wire\1Wire_1.h"
#include "I:\__Lib\LibLCD\LCD_2803.h"
#include <usart.h>
#include <stdlib.h>
//---Configurazione PIC----------------------------------------------
#pragma config OSC=INTIO67 
#pragma config WDT=OFF     
#pragma config LVP=OFF     
#pragma config MCLRE=ON    
#pragma config PBADEN=OFF  
#pragma config BOREN=ON    
#pragma config PWRT=ON     
#pragma config DEBUG=OFF   
//---G E N E R I C   D E F I N I T I O N S---------------------------
#define pu2 PORTAbits.RA1
#define pu3 PORTAbits.RA3
#define LED1 LATAbits.LATA2
#define LED2 LATCbits.LATC0  
//---V A R I A B L E S-----------------------------------------------
unsigned char programma[]={"1-Wire DS1820_02.c, prog: 2138, dati: 418 15-06-2011"};
unsigned char not_present[]="DS1820 manca";
unsigned char dev_present[]="DS1820 presente";
unsigned char ser_num[]="Seriale N: ";
unsigned char dato,abil_pu2,abil_pu3;
unsigned int cont_pu2,cont_pu3;
int temp,gradi,dec;
unsigned long conta;
char nume_vis[15];
//---P R O T O T Y P E S---------------------------------------------
void ApreUSART(void);
void Trasm_USART(unsigned char *);
void Legge_Seriale(void);
int Legge_temp(void);
unsigned char Detect_Slave_Device(void);
void hex_ascii(unsigned char);
//---Funzione principale---------------------------------------------
void main(void)
{ LATA=0;
  TRISA=0B11111011;      
  LATB=0;
	TRISB=0B00000000;	     
  LATC=0;
  TRISC=0B10011000;
  //
  OSCCON=0B01110000;       
  OSCTUNEbits.PLLEN=1;   
	CMCON=0x07;            
  ADCON1=0b00001111;     
  ADCON2=0b10110100;     
  ADCON0=0b00000001;     
  INTCON2bits.RBPU=0;    
  T0CONbits.TMR0ON=0;              
  INTCONbits.TMR0IF=0;   
  INTCONbits.TMR0IE=0;   
  INTCON2bits.TMR0IP=0;  
  PIR1bits.RCIF=0;       
  PIE1bits.RCIE=0;       
  IPR1bits.RCIP=0;       
  RCONbits.IPEN=0;       
  INTCONbits.GIE=0;      
  INTCONbits.PEIE=0;     
  ApreUSART();  //Inizializza USART.
  OpenLCD();    //Iniziakizza LCD.
  ClearLCD();   //Pulisce LCD.  
  abil_pu2=1,abil_pu3=1;
  if(!Detect_Slave_Device())	 //1-wire presente?
  {	Trasm_USART(not_present);	 //Vis. 1-wire non presente. 
  }
  else
  {	Legge_Seriale();
    WriteUSART('\n');
    Trasm_USART(programma);
  } 
  conta=0;
  //---Loop----------------------------------------------------------
  while(1)
  { conta++;
    if(conta>500000)
    { conta=0;
      LED1=1;
      temp=Legge_temp();
      gradi=temp/10;
      dec=temp-gradi*10;
      HomeLCD();
      WriteStringLCD("Temp: ");
      WriteVarLCD(itoa(gradi,nume_vis));
      WriteStringLCD(".");
      WriteVarLCD(itoa(dec,nume_vis));
      LED1=0;
    }
  } //Loop while(1)  
} // END OF MAIN
//---Apre USART------------------------------------------------------
void ApreUSART(void)
{ OpenUSART(USART_TX_INT_OFF&
            USART_RX_INT_OFF&
            USART_ASYNCH_MODE&
            USART_EIGHT_BIT&
            USART_CONT_RX&
            USART_BRGH_HIGH,103);
}
//---Rileva DS1829---------------------------------------------------            
unsigned char Detect_Slave_Device(void)
{	if (!OW_reset_pulse())
		return HIGH;     //DS1820 present.
	else 		
		return LOW;      //DS1820 not present.
}	
//---Legge il Seriale del DS1820-------------------------------------
void Legge_Seriale(void)
{ unsigned char temp;
  unsigned char temp1;
  unsigned char serial_number[8];
  Trasm_USART(dev_present);	 //Vis. 1-wire present.
  OW_write_byte (0x33); //Salta seriale.
  Trasm_USART(ser_num);	//Invia "Serial N"  all'USART.
  for(temp = 0; temp<8; temp++)
  { serial_number[temp] = OW_read_byte(); //Legge 8 byte del seriale.
    for(temp = 0; temp<8; temp++)
	  { hex_ascii(serial_number[temp]); //Converte da Hex a ASCII.
    }
  }
} 
//---Converte esadecimale in ASCII-----------------------------------
void hex_ascii(unsigned char display_data)
{ unsigned char temp;
	temp = ((display_data & 0xF0)>>4);
	if (temp <= 0x09)
	{	WriteUSART(temp+'0');	
		while(BusyUSART());
		WriteUSART(' ');	
		while(BusyUSART());
  } 
  else
  { WriteUSART(temp+'0'+0x07); 
    while(BusyUSART());
    WriteUSART(' ');	
		while(BusyUSART());
    temp = display_data & 0x0F;
  }
}	
//---Trasmissione stringa all'USART----------------------------------
void Trasm_USART(unsigned char *s)
{ WriteUSART('\n');
  while(*s!='\0')
  { WriteUSART(*s++);
    while(BusyUSART());
  }
} 
//---Legge la temperatura e la visualizza---------------------------- 
int Legge_temp(void)
{ unsigned char i; 
  unsigned char dataLow,dataHigh,TReading,SignBit,Whole,Fract;
  int ritorna;
  OW_reset_pulse();       //Reset.
  OW_write_byte(0xCC);    //Skip ROM
  OW_write_byte(0x44);    //Convert T
  for(i=0;i<2;i++);       //Ritardo.
  while(OW_read_byte()!=0xff); //Legge Busy flag.
  for(i=0;i<2;i++);       //Ritardo.
  OW_reset_pulse();       //Reset. 
  OW_write_byte(0xCC);    //Skip ROM.
  OW_write_byte(0xBE);    //Read Scratchpad
  dataLow=OW_read_byte();          //Legge il byte basso.
  dataHigh=OW_read_byte();         //Legge il byte alto.
  TReading=(dataHigh>>8)+dataLow;  //Bit 0 di dataHigh per decine+unit.
  SignBit=TReading & 0x80;       //Estrae il segno. 0x80
  Whole=TReading>>1;        //Gradi, numero intero
  Fract=TReading & 0x01;  //Gradi, decimale. 0x01
  if(Fract>0)
  { ritorna=(int) Whole*10+5;
  }
  else
  { ritorna=(int)Whole*10;
  }
  return ritorna;
}

       
